package parsers.CPA;

import parsers.CPA.*;
import util.Color;
import java.util.*;

class CellState
{
    String state;
    Color color;
    CellEmissionList CEList;
    CellEmissionList CDList;
    CellTransitionList CTList;
    
    CellState (String p_state, Color p_color,
	       CellEmissionList p_celist, CellEmissionList p_cdlist, CellTransitionList p_ctlist)
    {
	state = p_state;
	color = p_color;
	CTList = p_ctlist;
	CEList = p_celist;
	CDList = p_cdlist;
    }
    
    String getState()
    {
	return new String(state);
    }
    
    Color getColor()
    {
	return new Color(color);
    }
    
    CellTransitionList getCellTransitionList()
    {
	return CTList;
    }
    
    Vector getCellEmissionList()
    {
	if(CEList == null)
	    return new Vector();
	else
	    return CEList.getList();
    }
    
    Vector getCellDiffusionList()
    {
	if(CDList == null)
	    return new Vector();
	else
	    return CDList.getList();
    }
    
    public String toString ()
    {
	StringBuffer retVal = new StringBuffer("");
	
	retVal.append("state " + state + " {\n");
	if(color != null)
	    {
		retVal.append("\tcolor " + color.toString() + "\n");
	    }
	if(CEList != null)
	    {
		retVal.append("\temits " + CEList.toString() + "\n");
	    }
	if(CDList != null)
	    {
		retVal.append("\tdiffuses " + CDList.toString() + "\n");
	    }
	retVal.append("\ttransitions\n" + CTList.toString());
	retVal.append("}\n\n");
	return retVal.toString();
    }
}
