package gui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

import gui.*;

class MainWindow extends JFrame implements WindowListener
{
	SimWinMgr simWinMgr;

	public MainWindow(String[] args)
	{
		super("Cell Simulator");
		Container mainContainer = getContentPane();
		simWinMgr = new SimWinMgr(args);
		mainContainer.add(simWinMgr, BorderLayout.CENTER);

		JMenuBar mainMenu = new MainMenu(simWinMgr);
		setJMenuBar(mainMenu);
		JToolBar mainToolBar = new MainToolBar(simWinMgr);
		mainContainer.add(mainToolBar, BorderLayout.NORTH);

		setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
		addWindowListener(this);
	}

	public void windowClosing(WindowEvent e)
	{
		if(simWinMgr.exit())
			System.exit(0);
	}
	public void windowOpened(WindowEvent e)	{ }
	public void windowIconified(WindowEvent e) { }
	public void windowDeiconified(WindowEvent e) { }
	public void windowActivated(WindowEvent e) { }
	public void windowDeactivated(WindowEvent e) { }
	public void windowClosed(WindowEvent e) { }
}
