package parsers.CPA;

import parsers.CPA.*;
import util.ChemicalConditionList2;

class CellTransition
{
	ChemicalConditionList2 CCList = new ChemicalConditionList2();
	CellEmissionList CEList = new CellEmissionList();
	CellEmissionList CSList = new CellEmissionList();
	CellEmissionList CDList = new CellEmissionList();
	boolean isCellDivision;
	boolean isCellDeath;
	CellDivision division = null;
	CellStateChange stateChange = null;

	CellTransition (ChemicalConditionList2 p_CCList, CellDivision p_Division)
	{
		isCellDeath = false;
		isCellDivision = true;
		CCList = p_CCList;
		division = p_Division;
	}

	CellTransition (ChemicalConditionList2 p_CCList, CellStateChange p_Change)
	{
		isCellDeath = false;
		isCellDivision = false;
		CCList = p_CCList;
		stateChange = p_Change;
		CEList = new CellEmissionList();
	}

	CellTransition (ChemicalConditionList2 p_CCList)
	{
		isCellDeath = true;
		isCellDivision = false;
		CCList = p_CCList;
		CEList = new CellEmissionList();
	}

	ChemicalConditionList2 getChemicalConditionList()
	{
		return CCList;
	}

	CellDivision getCellDivision()
	{
		return division;
	}

	CellStateChange getCellStateChange()
	{
		return stateChange;
	}

	void addCellEmissionList(CellEmissionList p_CEList)
	{
		CEList = p_CEList;
	}
	
	void addCellStorageList(CellEmissionList p_CSList)
	{
		CSList = p_CSList;
	}
	
	void addCellDiffusionList(CellEmissionList p_CDList)
	{
		CDList = p_CDList;
	}
	
	CellEmissionList getCellEmissionList()
	{
		if(CEList != null)
			return CEList;
		else
			return new CellEmissionList();
	}

	CellEmissionList getCellStorageList()
	{
		if(CSList != null)
			return CSList;
		else
			return new CellEmissionList();
	}

	CellEmissionList getCellDiffusionList()
	{
		if(CDList != null)
			return CDList;
		else
			return new CellEmissionList();
	}

	public String toString ()
	{
		if(isCellDeath)
		{
			return CCList.toString() + " -> die\n" + CEList.toString() + CSList.toString();
		}
		if(isCellDivision)
		{
			return CCList.toString() + " -> " + division.toString() + "\n" + CEList.toString() + CSList.toString();
		}
		else
		{
			return CCList.toString() + " -> " + stateChange.toString() + "\n" + CEList.toString() + CSList.toString();
		}
	}
}
