package util;

public class CellEmission
{
	private String chemical;
	private String operator;
	private double concentration;
	private String direction;

	public CellEmission (String p_chem)
	{
		chemical = p_chem;
		concentration = 0.0;
		operator = null;
		direction = "any";
	}

	public CellEmission (String p_chem, String p_operator, double p_conc, String p_direction)
	{
		chemical = p_chem;
		operator = p_operator;
		concentration = p_conc;
		direction = p_direction;
	}

	public CellEmission (String p_chem, double p_conc, String p_direction)
	{
		chemical = p_chem;
		operator = null;
		concentration = p_conc;
		direction = p_direction;
	}

	public CellEmission (CellEmission ce)
	{
		chemical = ce.getChemical();
		operator = ce.getOperator();
		concentration = ce.getConcentration();
		direction = ce.getDirection();
	}

	public String getChemical () { return new String(chemical); }

	public String getOperator () { return operator; }

	public double getConcentration () { return concentration; }

	public String getDirection () { return direction; }

	public void setChemical (String p_chem) { chemical = p_chem; }

	public void setOperator (String p_oper) { operator = p_oper; }

	public void setConcentration (double p_conc) { concentration = p_conc; }

	public void setDirection (String p_dir) { direction = p_dir; }

	public String toString ()
	{
		if(direction != null)
			if(operator != null)
				return "(" + chemical.toString() + operator + concentration + ")" + " in " + direction + " direction";
			else
				return "(" + chemical.toString() + "," + concentration + ")" + " in " + direction + " direction";
		else
			if(operator != null)
				return "(" + chemical.toString() + operator + concentration + ")" + " in "+ "all directions";
			else
				return "(" + chemical.toString() + "," + concentration + ")" + " in " + "all directions";
	}
}
